package gq.unurled.raxen;

import com.archyx.aureliumskills.api.AureliumAPI;
import com.comphenix.protocol.ProtocolLibrary;
import com.comphenix.protocol.ProtocolManager;
import gq.unurled.raxen.config.Config;
import gq.unurled.raxen.config.PlayerConfig;
import gq.unurled.raxen.manager.*;
import gq.unurled.raxen.utils.LuckPerm;
import gq.unurled.raxen.utils.MongoDB;
import gq.unurled.raxen.utils.Reload;
import lombok.Getter;
import net.kyori.adventure.text.Component;
import org.bukkit.ChatColor;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.logging.Logger;

public final class Raxen extends JavaPlugin {

    private static final String prefix = ChatColor.AQUA + "Rx" + ChatColor.LIGHT_PURPLE + "> ";
    @Getter
    private static final String version = "0.0.1";
    private final PluginManager pm = getServer().getPluginManager();

    private static Raxen plugin;

    private static Logger logger;

    private static MongoDB mongoDB;

    private static Config config;

    private static PlayerManager playerManager;
    private static ProfileManager profileManager;
    private static PlayerConfig playerConfig;

    private static ListenerManager listenerManager;
    private static CommandManager commandManager;

    @Getter
    private ProtocolManager protocolManager;
    @Getter
    public AureliumAPI aureliumAPI;
    @Getter
    public LuckPerm luckPerm;

    @Override
    public void onEnable() {
        plugin = this;
        logger = getLogger();
        mongoDB = new MongoDB();
        //config = new Config(this);

        profileManager = new ProfileManager(this);
        listenerManager = new ListenerManager(this);
        commandManager = new CommandManager(this);
        protocolManager = ProtocolLibrary.getProtocolManager();

        playerConfig = new PlayerConfig(this);
        aureliumAPI = new AureliumAPI();
        luckPerm = new LuckPerm(this);
        luckPerm.register();

        registerCommands();
        registerEvents();

        getServer().getConsoleSender().sendMessage(Component.text(prefix +"§aServer Started Successfully!"));
    }

    private void registerCommands() {
        commandManager.register();

        getServer().getConsoleSender().sendMessage(Component.text(prefix +"§aCommands Registered!"));
    }

    private void registerEvents() {
        listenerManager.register();

        getServer().getConsoleSender().sendMessage(Component.text(prefix +"§aEvents Registered!"));
    }

    @Override
    public void onDisable() {
        Reload.kickAll();

        getServer().getConsoleSender().sendMessage(Component.text(prefix +"§cServer Stopped Successfully!"));
    }

    public static Logger getPluginLogger() {
        return logger;
    }

    public PluginManager getPm() {
        return pm;
    }

    public static Raxen getPlugin() {
        return plugin;
    }

    public static String getPrefix() {
        return prefix;
    }

    public static ProfileManager getProfileManager() {
        return profileManager;
    }

    public static PlayerManager getPlayerManager() {
        return playerManager;
    }

    public static MongoDB getMongoDB() {
        return mongoDB;
    }

    public static PlayerConfig getPlayerConfig() {
        return playerConfig;
    }
}
