package gq.unurled.raxen.commands.admin;

import de.tr7zw.changeme.nbtapi.NBTItem;
import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.player.Skills;
import gq.unurled.raxen.manager.ProfileManager;
import net.kyori.adventure.text.Component;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.List;

import static gq.unurled.raxen.utils.Skills.updateSkills;
import static gq.unurled.raxen.utils.Utils.*;

public class NbtCommand implements TabExecutor {

    private ProfileManager profileManager;

    public NbtCommand(Raxen main) {
        this.profileManager = main.getProfileManager();
    }

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command cmd, @NotNull String msg, @NotNull String[] args) {
        if(!(sender instanceof Player)) {
            error(color("&cYou can't execute this command as the Console!"));
            return true;
        }
        Player player = (Player) sender;
        if(player.getInventory().getItemInMainHand().getType() == Material.AIR || player.getInventory().getItemInMainHand() == null) {
            msgPlayer(player,color("&cYou must hold an Item in hand."));
            return true;
        }
        switch (args.length) {
            case 0:
            case 1:
                msgPlayer(player, color("&cYou must specify an nbt and an int."));
                break;
            case 2:
                log("'"+args[0]+"'", "'"+args[1]+"'");
                ItemStack it = player.getInventory().getItemInMainHand();
                NBTItem nbti = new NBTItem(it);
                int a = 0;
                if(nbti.hasKey(args[1])) {
                    a = nbti.getInteger(args[1]);
                }
                List<Component> lore = new ArrayList<>();
                ItemMeta itm = it.getItemMeta();
                lore.add((Component) itm.lore());
                Boolean yes = false;
                Boolean ever = false;
                for(Component ct : lore) {
                    if (ct != null) {
                        if (ct.contains(Component.text("Attributes:"))) {
                            yes = true;
                            ever = true;
                        } else {
                            if (yes) {
                                ct.append(Component.text(color(attributes(args[0]) + ": " + (Integer.parseInt(args[1]) + a))));
                                yes = false;
                            }
                        }
                    }
                }
                if(!ever) {
                    lore.add(Component.text(color("&cAttributes:")));
                    lore.add(Component.text(color(attributes(args[0]) + ": " + (Integer.parseInt(args[1]) + a) )));
                }
                itm.lore(lore);
                it.setItemMeta(itm);
                Skills skills = profileManager.getPlayerProfile(player.getUniqueId()).getSkils();
                nbti.setInteger(args[0], Integer.parseInt(args[1]) + a);
                if(nbti.hasKey("SPEED")) {
                    skills.addSpeed(nbti.getInteger("SPEED"));
                }
                if(nbti.hasKey("HEALTH")) {
                    skills.addHealth(nbti.getInteger("HEALTH"));
                }
                if(nbti.hasKey("DEFENSE")) {
                    skills.addDefense(nbti.getInteger("DEFENSE"));
                }
                if(nbti.hasKey("STRENGTH")) {
                    skills.addStrength(nbti.getInteger("STRENGTH"));
                }
                it = nbti.getItem();
                msgPlayer(player, Raxen.getPrefix() + color("&fYou successfully added the nbt " +attributes(args[0]) + "&fwith " + args[1] + "&f."));
                updateSkills(player);
                player.getInventory().setItem(player.getInventory().getHeldItemSlot(), it);
        }
        return true;
    }


    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String alias, @NotNull String[] args) {
        return null;
    }
}
