package gq.unurled.raxen.commands.player;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.player.Skills;
import gq.unurled.raxen.manager.ProfileManager;
import net.kyori.adventure.text.Component;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;

import static gq.unurled.raxen.utils.Utils.*;

public class SkillsCommand implements TabExecutor {

    private ProfileManager profileManager;

    public SkillsCommand(Raxen main) {
        this.profileManager = main.getProfileManager();
    }

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String msg, @NotNull String[] args) {
        if(!(sender instanceof Player)) {
            error("The console can't execute this Command!");
            return true;
        }
        Player player = (Player) sender;
        Skills skills = profileManager.getPlayerProfile(player.getUniqueId()).getSkils();
        switch (args.length) {
            case 0:
                //open gui
                player.sendMessage(Component.text(color("&cGUI not implemented yet..")).append(Component.text(color("&cTry /skill help."))));
                break;
            case 1:
            case 2:
                player.sendMessage(Component.text(color("&fUse the command like: "))
                        .append(Component.text(color("&f/skill &3{health|defense|speed|strength} {add|set|remove} {amount}"))));
                break;
            case 3:
                switch (args[0]) {
                    case "health":
                        if(args[1].equalsIgnoreCase("add")) {
                            skills.setHealth(skills.getHealth() + Integer.parseInt(args[2]));
                            msgPlayer(player,"You were added " + args[2] + " health more!");
                        }
                        if(args[1].equalsIgnoreCase("set")) {
                            skills.setHealth(Integer.parseInt(args[2]));
                            msgPlayer(player,"You are set " + args[2] + " health!");
                        }
                        if(args[1].equalsIgnoreCase("remove")) {
                            skills.setHealth(skills.getHealth() - Integer.parseInt(args[2]));
                            msgPlayer(player,"You were removeded " + args[2] + " health less!");

                        }
                        break;
                    case "defense":
                        if(args[1].equalsIgnoreCase("add")) {
                            skills.setDefense(skills.getDefense() + Integer.parseInt(args[2]));
                            msgPlayer(player,"You were added " + args[2] + " defense more!");

                        }
                        if(args[1].equalsIgnoreCase("set")) {
                            skills.setDefense(Integer.parseInt(args[2]));
                            msgPlayer(player,"You are set " + args[2] + " defense!");
                        }
                        if(args[1].equalsIgnoreCase("remove")) {
                            skills.setDefense(skills.getDefense() - Integer.parseInt(args[2]));
                            msgPlayer(player,"You were removed " + args[2] + " defense less!");
                        }
                        break;
                    case "speed":
                        if(args[1].equalsIgnoreCase("add")) {
                            skills.setSpeed(skills.getSpeed() + Integer.parseInt(args[2]));
                            msgPlayer(player,"You were added " + args[2] + " speed more!");
                        }
                        if(args[1].equalsIgnoreCase("set")) {
                            skills.setSpeed(Integer.parseInt(args[2]));
                            msgPlayer(player,"You are set " + args[2] + " speed!");
                        }
                        if(args[1].equalsIgnoreCase("remove")) {
                            skills.setSpeed(skills.getSpeed() - Integer.parseInt(args[2]));
                            msgPlayer(player,"You were removed " + args[2] + " speed less!");
                        }
                        break;
                    case "stregnth":
                        if(args[1].equalsIgnoreCase("add")) {
                            skills.setStrength(skills.getStrength() + Integer.parseInt(args[2]));
                            msgPlayer(player,"You were added " + args[2] + " strength more!");
                        }
                        if(args[1].equalsIgnoreCase("set")) {
                            skills.setStrength(Integer.parseInt(args[2]));
                            msgPlayer(player,"You are set " + args[2] + " strength!");
                        }
                        if(args[1].equalsIgnoreCase("remove")) {
                            skills.setStrength(skills.getStrength() - Integer.parseInt(args[2]));
                            msgPlayer(player,"You were removed " + args[2] + " strength less!");
                        }
                        break;
                }
                gq.unurled.raxen.utils.Skills.updateSkills(player);
        }
        return false;
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String alias, @NotNull String[] args) {
        return null;
    }
}
