package gq.unurled.raxen.listener.player;

import com.destroystokyo.paper.event.player.PlayerArmorChangeEvent;
import de.tr7zw.changeme.nbtapi.NBTItem;
import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.player.Skills;
import gq.unurled.raxen.manager.ProfileManager;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;

public class ArmorEvent implements Listener {

    private ProfileManager profileManager;

    public ArmorEvent(Raxen main) {
        this.profileManager = main.getProfileManager();
    }

    @EventHandler
    public void ArmorChangeEvent(PlayerArmorChangeEvent e) {
        Player player = e.getPlayer();
        Skills skills = profileManager.getPlayerProfile(player.getUniqueId()).getSkils();
        if(e.getOldItem() != null && e.getOldItem().getType() != Material.AIR) {
            ItemStack oldItem = e.getOldItem();
            NBTItem nbti = new NBTItem(oldItem);
            if(nbti.hasKey("SPEED")) {
                skills.removeSpeed(nbti.getInteger("SPEED"));
            }
            if(nbti.hasKey("HEALTH")) {
                skills.removeHealth(nbti.getInteger("HEALTH"));
            }
            if(nbti.hasKey("DEFENSE")) {
                skills.removeDefense(nbti.getInteger("DEFENSE"));
            }
            if(nbti.hasKey("STRENGTH")) {
                skills.removeStrength(nbti.getInteger("STRENGTH"));
            }
        }
        if(e.getNewItem() != null && e.getNewItem().getType() != Material.AIR) {
            ItemStack newItem = e.getNewItem();
            NBTItem nbti = new NBTItem(newItem);
            if(nbti.hasKey("SPEED")) {
                skills.addSpeed(nbti.getInteger("SPEED"));
            }
            if(nbti.hasKey("HEALTH")) {
                skills.addHealth(nbti.getInteger("HEALTH"));
            }
            if(nbti.hasKey("DEFENSE")) {
                skills.addDefense(nbti.getInteger("DEFENSE"));
            }
            if(nbti.hasKey("STRENGTH")) {
                skills.addStrength(nbti.getInteger("STRENGTH"));
            }
        }
        gq.unurled.raxen.utils.Skills.updateSkills(player);
    }
}
