package gq.unurled.raxen.manager;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.player.Inventories;
import gq.unurled.raxen.components.player.Profile;
import gq.unurled.raxen.components.player.Skills;
import gq.unurled.raxen.components.player.Storage;
import gq.unurled.raxen.components.player.Storages.EnderChest;
import gq.unurled.raxen.components.player.Storages.Inventory;
import net.kyori.adventure.text.Component;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryType;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

import static gq.unurled.raxen.utils.Utils.log;

public class ProfileManager {

    private Raxen main;
    private Map<UUID, Profile> profiles = new HashMap<>();
    private Map<UUID, Storage> storages = new HashMap<>();
    private Map<UUID, Inventories> inventory = new HashMap<>();

    public ProfileManager(Raxen main) {
        this.main = main;
    }

    public Profile createNewProfile(Player player) {
        Skills skills = new Skills( 100, 50, 100, 100);
        Profile profile = new Profile(skills);
        profiles.put(player.getUniqueId(), profile);
        return profile;
    }

    public Profile getPlayerProfile(UUID uuid) {
        return profiles.get(uuid);
    }

    public void setPlayerProfile(UUID uuid, Profile profile) {
        if(profiles.get(uuid) == null) {
            profiles.put(uuid, profile);
        }
        else {
            profiles.replace(uuid, profile);
        }
        log("Profile Updated!");
    }

    public Storage createNewStorage(Player player) {
        EnderChest ec = new EnderChest(Bukkit.createInventory(null, 54, Component.text("Ender Chest")));
        Storage storage = new Storage(ec);
        storages.put(player.getUniqueId(), storage);
        return storage;
    }

    public Storage getPlayerStorage(UUID uuid) {
        return storages.get(uuid);
    }

    public void setPlayerStorage(UUID uuid, Storage storage) {
        if(storages.get(uuid) == null) {
            storages.put(uuid, storage);
        }
        else {
            storages.replace(uuid, storage);
        }
        log("Storage Updated!");
    }

    public Inventories createNewInventory(Player player) {
        Inventory inv = new Inventory(Bukkit.createInventory(null, InventoryType.PLAYER));
        Inventories inves = new Inventories(inv);
        inventory.put(player.getUniqueId(), inves);
        return inves;
    }

    public Inventories getPlayerInventory(UUID uuid) {
        return inventory.get(uuid);
    }

    public void setPlayerInventory(UUID uuid, Inventories inventories) {
        if(inventory.get(uuid) == null) {
            inventory.put(uuid, inventories);
        }
        else {
            inventory.replace(uuid, inventories);
        }
        log("Inventory Updated!");
    }

}
